import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.processing.Processor;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;

import net.javainthebox.annotation.AbstractionProcessor;

public class AnnotationProcessorSample1 {
    public AnnotationProcessorSample1() {
        // RpC̎擾
        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();

        // zt@C}l[W̎擾
        StandardJavaFileManager fileManager 
            = compiler.getStandardFileManager(null, null, null);

        // RpCt@C̏
        Iterable<? extends JavaFileObject> fileobjs =
            fileManager.getJavaFileObjects("Sample.java");

        // Ame[VvZbT
        List<String> processorFiles = new ArrayList<String>();
        processorFiles.add(
            "net.javainthebox.annotation.AbstractionProcessor");

        // ^XN̎擾
        JavaCompiler.CompilationTask task 
            = compiler.getTask(null, // G[o
                               fileManager, // t@C}l[W
                               null, // DiagnosticListener
                               null, // RpCIvV
                               processorFiles, // Ame[VvZbT
                               fileobjs); // \[Xt@C
  
        // ^XNɃAme[VvZbTIuWFNgZbg
        List<Processor> processors 
            =  new ArrayList<Processor>();
        processors.add(new AbstractionProcessor());
        task.setProcessors(processors);

        // RpCƃAme[V̎s
        if (task.call()) {
            System.out.println("Success");
        } else {
            System.out.println("Fail");
        }
 
        // t@C}[W[N[Y
        try {
            fileManager.close();
        } catch (IOException ex) {
            // O
        }
    }

    public static void main(String[] args) {
        new AnnotationProcessorSample1();
    }
}


